#!/usr/bin/python
# -*- coding: utf-8 -*-

from __future__ import division
import random, string, locale, gettext
import sys, os
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_lecture.affichage_image.afficheurImage import VisionneurImagePourEKD
from gui_modules_image.image_base import Base
from gui_modules_image.selectWidget import SelectWidget
from gui_modules_lecture.lecture_image import Lecture_VisionImage 
from gui_modules_lecture.affichage_image.afficheurImage import VisionneurEvolue

# Nouvelle boite de dialogue pour sauver les fichiers
from gui_modules_common.EkdWidgets import EkdSaveDialog

###############
from moteur_modules_common.EkdCompatiblePython2Et3 import EkdPrint
###############

if sys.version_info[:2] < (2, 5):
	def partial(func, arg):
		def callme():
			return func(arg)
		return callme
else:
	from functools import partial

# Gestion de la configuration via EkdConfig
from moteur_modules_common.EkdConfig import EkdConfig
# Nouvelle fenêtre d'aide ######
from gui_modules_common.EkdWidgets import EkdAide

PointSize = 60

FORMAT = "JPEG (*.jpg *.JPG *.jpeg *.JPEG);;PNG (*.png *.PNG);;GIF (*.gif *.GIF)\
	;;BMP (*.bmp *.BMP);;SGI (*.sgi *.SGI);;TIF (*.tif *.TIF);;TARGA (*.tga *.TGA)\
	;;PNM (*.pnm *.PNM);;PPM (*.ppm *.PPM);;Tous les fichiers (*.*)"


class TextItemDlg(QDialog):
	"Boite de dialogue de texte"
	def __init__(self, item=None, position=None, scene=None,
			parent=None, z=1):
		QDialog.__init__(self, parent)
		
		self.item = item
		self.position = position
		self.scene = scene
		self.z = z
		
		self.editor = QTextEdit()
		self.editor.setAcceptRichText(False)
		self.editor.setTabChangesFocus(True)
		editorLabel = QLabel(_(u"&Texte:"))
		editorLabel.setBuddy(self.editor)
		self.fontComboBox = QFontComboBox()
		self.fontComboBox.setCurrentFont(QFont("Sans Serif", PointSize))
		fontLabel = QLabel(_(u"&Police:"))
		fontLabel.setBuddy(self.fontComboBox)
		self.fontSpinBox = QSpinBox()
		self.fontSpinBox.setAlignment(Qt.AlignRight|Qt.AlignVCenter)
		self.fontSpinBox.setRange(6, 280)
		self.fontSpinBox.setValue(PointSize)
		fontSizeLabel = QLabel(_(u"&Taille:"))
		fontSizeLabel.setBuddy(self.fontSpinBox)
		self.fontComboColor = QComboBox()
		
		self.listComboColor=[	(_(u'défaut'),		QColor(QPalette.Text)),
					(_(u'noir'),		QColor('#000000')),
					(_(u'gris foncé'),	QColor('#808080')),
					(_(u'gris'),		QColor('#a0a0a4')),
					(_(u'gris clair'),	QColor('#c0c0c0')),
					(_(u'blanc'),		QColor('#ffffff')),
					(_(u'rouge'),		QColor('#ff0000')),
					(_(u'rouge foncé'),	QColor('#800000')),
					(_(u'vert'),		QColor('#00ff00')),
					(_(u'vert foncé'),	QColor('#008000')),
					(_(u'bleu'),		QColor('#0000ff')),
					(_(u'bleu foncé'),	QColor('#000080')),
					(_(u'cyan'),		QColor('#00ffff')),
					(_(u'cyan foncé'),	QColor('#008080')),
					(_(u'magenta'),		QColor('#ff00ff')),
					(_(u'magenta foncé'),	QColor('#800080')),
					(_(u'jaune'),		QColor('#ffff00')),
					(_(u'jaune foncé'),	QColor('#808000')),
						]
		
		font =QFont()
		fm = QFontMetricsF(font)
		hauteurPixmap = fm.height() - 2 # icones espacées de 2 pixels
		
		for i in self.listComboColor:
			pixmap = QPixmap(hauteurPixmap, hauteurPixmap)
			color = i[1]
			pixmap.fill(color)
			self.fontComboColor.addItem(QIcon(pixmap), i[0], QVariant(i[1]))
		fontColorLabel = QLabel(_(u"&Couleur:"))
		fontColorLabel.setBuddy(self.fontComboColor)
		self.buttonBox = QDialogButtonBox(QDialogButtonBox.Ok|
						QDialogButtonBox.Cancel)
		self.buttonBox.button(QDialogButtonBox.Ok).setEnabled(False)
		
		if self.item is not None:
			self.editor.setPlainText(self.item.toPlainText())
			self.fontComboBox.setCurrentFont(self.item.font())
			self.fontSpinBox.setValue(self.item.font().pointSize())
			for i, tColor in enumerate(self.listComboColor):
				if tColor[1]==self.item.defaultTextColor(): break
			self.fontComboColor.setCurrentIndex(i)
			self.editor.setTextColor(self.item.defaultTextColor())
		
		layout = QGridLayout()
		layout.addWidget(editorLabel, 0, 0)
		layout.addWidget(self.editor, 1, 0, 1, 9)
		layout.addWidget(fontLabel, 2, 0)
		layout.addWidget(self.fontComboBox, 2, 1, 1, 2)
		layout.addWidget(fontSizeLabel, 2, 3)
		layout.addWidget(self.fontSpinBox, 2, 4, 1, 2)
		layout.addWidget(fontColorLabel, 2, 6)
		layout.addWidget(self.fontComboColor, 2, 7, 1, 2)
		layout.addWidget(self.buttonBox, 3, 0, 1, 9)
		self.setLayout(layout)
	
		self.connect(self.fontComboBox,SIGNAL("currentFontChanged(QFont)"),self.updateUi)
		self.connect(self.fontSpinBox,SIGNAL("valueChanged(int)"),self.updateUi)
		self.connect(self.editor,SIGNAL("textChanged()"),self.updateUi)
		self.connect(self.fontComboColor, SIGNAL("activated(int)"),self.updateUi)
		self.connect(self.buttonBox, SIGNAL("accepted()"), self.accept)
		self.connect(self.buttonBox, SIGNAL("rejected()"), self.reject)
		txt1,txt2=_(u"Texte sur images"),_(u"texte")
		if self.item is None: txt3 = _(u"Ajouter")
		else:  txt3 = _(u"Editer")
		self.setWindowTitle("%s - %s %s" % (txt1, txt3, txt2))
		self.updateUi()

	def updateUi(self):
		font = self.fontComboBox.currentFont()
		font.setPointSize(self.fontSpinBox.value())
		self.editor.document().setDefaultFont(font)
		i = self.fontComboColor.currentIndex()
		styleSheet = "QTextEdit{color: %s}" %self.fontHexaColor()
		self.editor.setStyleSheet(styleSheet)
		self.buttonBox.button(QDialogButtonBox.Ok).setEnabled(
			not self.editor.toPlainText().isEmpty())

	def accept(self):
		if self.item is None:
			self.item = TextItem("", self.position, self.scene, z=self.z)
		font = self.fontComboBox.currentFont()
		font.setPointSize(self.fontSpinBox.value())
		self.item.setFont(font)
		self.item.setHtml(self.editor.toHtml())
		self.item.setDefaultTextColor(self.fontColor())
		self.item.update()
		QDialog.accept(self)
	
	def fontColor(self):
		"Renvoie la couleur de la police en type QColor"
		i = self.fontComboColor.currentIndex()
		color = self.fontComboColor.itemData(i).toString()
		return QColor(color)
	
	def fontHexaColor(self):
		"Renvoie la couleur de la police en type hexadécimal"
		return self.fontColor().toRgb().name()

class TextItemDlg2(QDialog):
	"Boite de dialogue de texte avancé"
	def __init__(self, item=None, position=QPoint(50, 50), z=1, scene=None, parent=None) :
		QDialog.__init__(self, parent)

		if item == None :
			self.new = 1
			self.item = BDStripItem("",position, scene, z=z)
		else :
			self.new = 0
			self.item = item
		self.editor = QTextEdit()
		self.editor.setAcceptRichText(False)
		self.editor.setTabChangesFocus(True)
		editorLabel = QLabel(_(u"&Texte:"))
		editorLabel.setBuddy(self.editor)
		self.fontComboBox = QFontComboBox()
		self.fontComboBox.setCurrentFont(QFont("Sans Serif", PointSize))
		fontLabel = QLabel(_(u"&Police:"))
		fontLabel.setBuddy(self.fontComboBox)
		self.fontSpinBox = QSpinBox()
		self.fontSpinBox.setAlignment(Qt.AlignRight|Qt.AlignVCenter)
		self.fontSpinBox.setRange(6, 280)
		self.fontSpinBox.setValue(PointSize)
		fontSizeLabel = QLabel(_(u"&Taille:"))
		fontSizeLabel.setBuddy(self.fontSpinBox)
		self.selectFontColor = QPushButton()
		self.selectFontColor.setPalette(QPalette(QColor(255,255,255)))		
		fontColorLabel = QLabel(_(u"&Couleur:"))
		fontColorLabel.setBuddy(self.selectFontColor)
		# Sélection de la forme de fond + choix couleur du fond
		self.shapeCombo = QComboBox()
		self.shapeCombo.addItem(QIcon("Icones/textRect.png"),_(u"Rectangle"))
		self.shapeCombo.addItem(QIcon("Icones/textRoundedRect.png"),_(u"Rectangle arrondi"))
		self.shapeCombo.addItem(QIcon("Icones/textEllipse.png"),_(u"Ellipse"))
		self.shapeCombo.addItem(QIcon("Icones/textStrip.png"),_(u"Bulle parole bas droit"))
		self.shapeCombo.addItem(QIcon("Icones/textStripBG.png"),_(u"Bulle parole bas gauche"))
		self.shapeCombo.addItem(QIcon("Icones/textStripHG.png"),_(u"Bulle parole haut gauche"))
		self.shapeCombo.addItem(QIcon("Icones/textStripHD.png"),_(u"Bulle parole haut droit"))
		self.shapeCombo.addItem(QIcon("Icones/textStripC.png"),_(u"Bulle carrée bas droit"))
		self.shapeCombo.addItem(QIcon("Icones/textStripCBG.png"),_(u"Bulle carrée bas gauche"))
		self.shapeCombo.addItem(QIcon("Icones/textStripCHG.png"),_(u"Bulle carrée haut gauche"))
		self.shapeCombo.addItem(QIcon("Icones/textStripCHD.png"),_(u"Bulle carrée haut droit"))
		self.shapeCombo.addItem(QIcon("Icones/textStripThink.png"),_(u"Bulle pensée"))
		shapeLabel = QLabel(_(u"Forme :"))
		shapeLabel.setBuddy(self.shapeCombo)
		self.transparence = QSpinBox()
		self.transparence.setRange(0, 100)
		transpLabel = QLabel(_(u"Opacité (%):"))
		transpLabel.setBuddy(self.transparence)
		self.backgroundColor = QPushButton()
		self.backgroundColor.setPalette(QPalette(QColor(255,255,255)))
		backColorLabel = QLabel(_(u"Couleur de fond:"))
		backColorLabel.setBuddy(self.backgroundColor)
		
		# Sélection de la couleur, épaisseur et style des traits
		self.styleTrait = QComboBox()
		self.listStyleTrait = [Qt.SolidLine, Qt.DashLine, Qt.DotLine, Qt.DashDotLine, Qt.DashDotDotLine, Qt.NoPen]
		self.styleTrait.addItem(QIcon("Icones/pen_plain.png"),_(u"Continu"))
		self.styleTrait.addItem(QIcon("Icones/pen_dash.png"),_(u"Interrompu"))
		self.styleTrait.addItem(QIcon("Icones/pen_points.png"),_(u"Pointillé"))
		self.styleTrait.addItem(QIcon("Icones/pen_dashPoint.png"),_(u"Barre point barre"))
		self.styleTrait.addItem(QIcon("Icones/pen_dashPointPoint.png"),_(u"Barre point point barre"))
		self.styleTrait.addItem(QIcon("Icones/noPen.png"),_(u"Aucun trait"))
		traitLabel = QLabel(_(u"Style de trait:"))
		traitLabel.setBuddy(self.styleTrait)
		self.epaisseurTrait = QSpinBox()
		self.epaisseurTrait.setRange(1, 100)
		epaisseurLabel = QLabel(_(u"Épaisseur:"))
		epaisseurLabel.setBuddy(self.epaisseurTrait)
		self.colorTrait=QPushButton()
		self.colorTrait.setPalette(QPalette(QColor(255,255,255)))
		colorLabel = QLabel(_(u"Couleur:"))
		colorLabel.setBuddy(self.colorTrait)
		
		self.buttonBox = QDialogButtonBox(QDialogButtonBox.Ok|
						QDialogButtonBox.Cancel)

		if self.item is not None:
			self.editor.setPlainText(self.item.toPlainText())
			self.fontComboBox.setCurrentFont(self.item.font)
			self.fontSpinBox.setValue(self.item.font.pointSize())
			self.selectFontColor.setPalette(QPalette(self.item.colorFont))
			self.shapeCombo.setCurrentIndex(self.item.typeShape)
			self.backgroundColor.setPalette(QPalette(self.item.background.color().toRgb()))
			self.transparence.setValue(int(self.item.background.color().alpha()/255*100))
			self.colorTrait.setPalette(QPalette(self.item.lineStyle.color()))
			self.epaisseurTrait.setValue(self.item.lineStyle.width())
			if self.item.lineStyle.style() == Qt.SolidLine : index = 0
			elif self.item.lineStyle.style() == Qt.DashLine : index = 1
			elif self.item.lineStyle.style() == Qt.DotLine : index = 2
			elif self.item.lineStyle.style() == Qt.DashDotLine : index = 3
			elif self.item.lineStyle.style() == Qt.DashDotDotLine : index = 4
			elif self.item.lineStyle.style() == Qt.NoPen : index = 5
			else : index = 0
			self.styleTrait.setCurrentIndex(index)
			self.editor.setTextColor(self.item.colorFont)

		layout = QGridLayout()
		layout.addWidget(editorLabel, 0, 0)
		layout.addWidget(self.editor, 1, 0, 1, 9)
		layout.addWidget(fontLabel, 2, 0)
		layout.addWidget(self.fontComboBox, 2, 1, 1, 2)
		layout.addWidget(fontSizeLabel, 2, 3)
		layout.addWidget(self.fontSpinBox, 2, 4, 1, 2)
		layout.addWidget(fontColorLabel, 2, 6)
		layout.addWidget(self.selectFontColor, 2, 7, 1, 2)
		layout.addWidget(shapeLabel,3,0)
		layout.addWidget(self.shapeCombo, 3, 1)
		layout.addWidget(backColorLabel, 3, 2)
		layout.addWidget(self.backgroundColor, 3, 3)
		layout.addWidget(transpLabel, 3, 4, 1, 2)
		layout.addWidget(self.transparence, 3, 6)
		layout.addWidget(traitLabel, 4, 0)
		layout.addWidget(self.styleTrait, 4, 1)
		layout.addWidget(epaisseurLabel, 4, 2)
		layout.addWidget(self.epaisseurTrait, 4, 3)
		layout.addWidget(colorLabel, 4, 4, 1, 2)
		layout.addWidget(self.colorTrait, 4, 6)
		layout.addWidget(self.buttonBox, 5, 0, 1, 9)
		self.setLayout(layout)

		self.connect(self.fontComboBox,SIGNAL("currentFontChanged(QFont)"),self.updateUi)
		self.connect(self.shapeCombo,SIGNAL("currentIndexChanged(int)"),self.changeShape)
		self.connect(self.styleTrait,SIGNAL("currentIndexChanged(int)"),self.changePen)
		self.connect(self.fontSpinBox,SIGNAL("valueChanged(int)"),self.updateUi)
		self.connect(self.transparence,SIGNAL("valueChanged(int)"),self.changeBackground)
		self.connect(self.epaisseurTrait,SIGNAL("valueChanged(int)"),self.changePen)
		self.connect(self.editor,SIGNAL("textChanged()"),self.updateUi)
		self.connect(self.selectFontColor, SIGNAL("clicked()"),self.chooseFontColor)
		self.connect(self.backgroundColor, SIGNAL("clicked()"),self.chooseBackColor)
		self.connect(self.colorTrait, SIGNAL("clicked()"),self.chooseColorTrait)
		self.connect(self.buttonBox, SIGNAL("accepted()"), self.accept)
		self.connect(self.buttonBox, SIGNAL("rejected()"), self.reject)
		txt1,txt2=_(u"Texte sur images"),_(u"texte")
		if self.item is None: txt3 = _(u"Ajouter")
		else:  txt3 = _(u"Editer")
		self.setWindowTitle("%s - %s %s" % (txt1, txt3, txt2))
		self.updateUi()

	def chooseFontColor(self) :
		color = QColorDialog.getColor(self.selectFontColor.palette().color(QPalette.Button))
		self.selectFontColor.setPalette(QPalette(color))
		self.updateUi()

	def chooseBackColor(self) :
		color = QColorDialog.getColor(self.backgroundColor.palette().color(QPalette.Button))
		self.backgroundColor.setPalette(QPalette(color))
		self.changeBackground(0)

	def chooseColorTrait(self) :
		color = QColorDialog.getColor(self.colorTrait.palette().color(QPalette.Button))
		self.colorTrait.setPalette(QPalette(color))
		self.changePen("color")
		
	def changePen(self, data) :
		pen = QPen(self.colorTrait.palette().color(QPalette.Button))
		pen.setStyle(self.listStyleTrait[self.styleTrait.currentIndex()])
		pen.setWidth(self.epaisseurTrait.value())
		self.item.lineStyle = pen
		self.item.update()

	def changeShape(self, index) :
		self.item.typeShape = index
		x=self.item.ellipse.x()
		y=self.item.ellipse.y()
		w=self.item.ellipse.width()
		h=self.item.ellipse.height()
		if index == 4 or index == 8 :
			self.item.selectBR.setPos(QPointF(-w, y+0.15*h))
			self.item.point = QPointF(x, y+1.15*h)
		elif index == 5 or index == 9 :
			self.item.selectBR.setPos(QPointF(-w, y-1.15*h))
			self.item.point = QPointF(x,y-0.15*h)
		elif index == 6 or index == 10 :
			self.item.selectBR.setPos(QPointF(0.0, y-1.15*h))
			self.item.point = QPointF(x+w,y-0.15*h)
		else :
			self.item.selectBR.setPos(QPointF(0.0, 0.0))
			self.point = QPointF(x+w, y+1.15*h)

		if index < 3 :
			self.item.selectBR.hide()
		else : self.item.selectBR.show()
		self.item.update()
		
	def changeBackground(self, index) :
		color = self.backgroundColor.palette().color(QPalette.Button)
		color.setAlpha(int(self.transparence.value()*255/100))
		self.item.background = QBrush(color)
		self.item.update()

	def updateUi(self):
		font = self.fontComboBox.currentFont()
		font.setPointSize(self.fontSpinBox.value())
		self.editor.document().setDefaultFont(font)
		styleSheet = "QTextEdit{color: %s}" %self.fontHexaColor()
		self.editor.setStyleSheet(styleSheet)

	def accept(self):
		if self.item is None:
			return
		font = self.fontComboBox.currentFont()
		font.setPointSize(self.fontSpinBox.value())
		self.item.setFont(font)
		self.item.setText(self.editor.toPlainText())
		self.item.setDefaultTextColor(self.fontColor())
		self.item.typeShape = self.shapeCombo.currentIndex()
		self.item.update()
		QDialog.accept(self)

	def fontColor(self):
		"Renvoie la couleur de la police en type QColor"
		color = self.selectFontColor.palette().color(QPalette.Button)
		return color

	def fontHexaColor(self):
		"Renvoie la couleur de la police en type hexadécimal"
		return self.fontColor().toRgb().name()

class grilleMagnetique(QGraphicsItem) :
	"""Grille de positionnement des images pour la présentation BD"""
	def __init__(self, width, height, row=1, column=1, parent=None) :
		"""Initialisation de la grille et affichage sur le QGraphicView"""
		self.width = width
		self.height = height
		self.row = row
		self.column = column
		super(grilleMagnetique, self).__init__(parent)
		self.setZValue(10000)
		self.setData(0,QVariant(QString("grille")))

	def boundingRect(self) :
		return QRectF(0.0, 0.0, float(self.width), float(self.height))

	def paint(self, painter, optionStyle, widget) :
		painter.setRenderHint(QPainter.Antialiasing)
		pen = QPen(QColor(255, 127, 0))
		pen.setStyle(Qt.DashDotLine)
		pen.setWidth(2)
		painter.setPen(pen)
		n=0
		while n<= self.row :
			y = n*float(self.height)/self.row
			painter.drawLine(0.0, y, self.width, y)
			n += 1
		n=0
		while n <= self.column :
			x = n * float(self.width)/self.column
			painter.drawLine(x, 0.0, x, self.height)
			n += 1
		
		
class carreRedim(QGraphicsRectItem) :
	"""Sub item pour indiquer les poignées de redimensionnement"""
	# coin = UL (Up Left), BR (Bottom Right), Pix (redimensionnement des images)
	def __init__(self, item, scene, z, coin="UL", parent=None) :
		self.item = item
		self.coin = coin
		if coin == "UL" :
			x=item.ellipse.x()
			y=item.ellipse.y()
		elif coin == "BR" :
			x=item.point.x()
			y=item.point.y()
		elif coin == "Pix" :
			x=self.item.pixmap().width()-20.0
			y=self.item.pixmap().height()-20.0
		elif coin == "Box" :
			x = self.item.rect.x()+self.item.rect.width()-20.0
			y = self.item.rect.y()+self.item.rect.height()-20.0
		w = 40.0
		h = 40.0
		
		super(carreRedim, self).__init__(x,y,w,h,parent)
		self.setZValue(z)
		self.setFlags(QGraphicsItem.ItemIsMovable | QGraphicsItem.ItemIsSelectable | QGraphicsItem.ItemSendsGeometryChanges)
		self.setData(0,QVariant(QString("control")))
		self.setCursor(Qt.SizeFDiagCursor)	
	
	def mouseMoveEvent(self, event) :
		"""Redéfinition de la fonction appelée lors de évenements de la souris sur la poignée"""
		QGraphicsItem.mouseMoveEvent(self, event)
		p=event.scenePos()
		if self.scene().grilleMagnAct() and self.coin == "Pix" :
			x = p.x()
			y = p.y()
			gridx = self.scene().width() / self.scene().getColumn()
			n=0
			while n*gridx < p.x() :
				x = n*gridx
				n += 1
			gridy = self.scene().height() / self.scene().getRow()
			n=0
			while n*gridy < p.y() :
				y = n*gridy
				n += 1
			PF = QPointF(x, y)
		else :
			PF = p
		P = self.item.mapFromScene(PF)
		if self.coin == "UL" :
			deltax =event.lastScenePos().x()-event.scenePos().x()
			deltay =event.lastScenePos().y()-event.scenePos().y()
			w = deltax+self.item.ellipse.width()
			h = deltay+self.item.ellipse.height()
			self.item.ellipse = QRectF(P,QSizeF(w,h))
		elif self.coin == "BR" :
			self.item.point = P
		elif self.coin == "Pix" :
			ratio = self.item.pixmap().width()/self.item.pixmap().height()
			w1 = P.x() #self.item.pixmap().width()-deltax
			h1 = w1/ratio
			h2 = P.y() #self.item.pixmap().height()-deltay
			if h1<h2 :
				w=h2*ratio
				h = h2
			else :
				w = w1
				h = h1
			self.item.reduction = w/self.item.pixWidth
			self.item.setPixmap(QPixmap(self.item.imageFile).copy(self.item.cropX, \
							self.item.cropY, \
							self.item.cropWidth, \
							self.item.cropHeight).scaled(w, h, Qt.KeepAspectRatio, Qt.SmoothTransformation))
			self.setPos(w-self.item.pixWidth, h-self.item.pixHeight) #Nécessaire pour que le carré de redimensionnement soit toujours situé au coin inférieur droit.
		elif self.coin == "Box" :
			self.item.rect = QRectF(0.0, 0.0, P.x(), P.y())
		self.item.update()
		
class BDStripItem(QGraphicsItem):
	"Item pour des bulles BD"
	# typeShape = 0 -> Texte carré
	# typeShape = 1 -> Texte carré arrondi
	# typeShape = 2 -> Texte ellipse	
	# typeShape = 3 -> Bulle parole bas droit
	# typeShape = 4 -> Bulle parole bas gauche
	# typeShape = 5 -> Bulle parole haut gauche
	# typeShape = 6 -> Bulle parole haut droit
	# typeShape = 7 -> Bulle parole carrée bas droit
	# typeShape = 8 -> Bulle parole carrée bas gauche
	# typeShape = 9 -> Bulle parole carrée haut gauche
	# typeShape = 10 -> Bulle parole carrée haut droit
	# typeShape = 11 -> Bulle pensée
	orientation = 0 #0 = droite, 1 = gauche
	def __init__(self, text, position, scene, font=QFont("Sans Serif", PointSize), \
			colorFont=QColor(0,0,0), background=QBrush(QColor(220,220,255)), lineStyle=QPen(QColor(0,0,0)),\
			orientation=0, rotation=0, z=1, ellipse=QRectF(-200.0,-100.0,400.0,200.0), point=QPointF(200,160), typeShape=1) :
		QGraphicsItem.__init__(self)
		self.setPos(position)
		self.setFlags(QGraphicsItem.ItemIsSelectable|
				QGraphicsItem.ItemIsMovable)
		self.setCursor(Qt.SizeAllCursor)
		self.__rotation = rotation
		self.setZValue(z)
		self.font = font
		self.text = text
		self.colorFont = colorFont
		self.background = background
		self.lineStyle = lineStyle
		self.orientation = orientation
		self.ellipse = ellipse
		self.point = point
		self.typeShape = typeShape
		self.rect = QRectF(ellipse.x(), ellipse.y(), self.point.x()-ellipse.x(), self.point.y()-ellipse.y())
		scene.clearSelection()
		scene.addItem(self)
		self.setZValue(z)
		self.setSelected(True)
		self.setFocus()
		# Ajout des carrés de redimensionnement
		self.selectUL = carreRedim(self,scene,z+2,"UL",self)
		self.selectBR = carreRedim(self,scene,z+2,"BR",self)
		if self.typeShape < 3 :
			self.selectBR.hide()

	def boundingRect(self) :
		return self.rect

	def toPlainText(self) :
		return self.text

	def font(self) :
		return self.font

	def setText(self, text) :
		self.text = text

	def setFont(self, font) :
		self.font = font

	def setDefaultTextColor(self, color) :
		self.colorFont = color

	def mouseDoubleClickEvent(self, event) :
		editor = TextItemDlg2(self)
		editor.exec_()
		
	def setRotateR(self, rotation):
		self.__rotation += rotation
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(rotation)

	def setRotateL(self, rotation):
		self.__rotation -= rotation
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(-rotation)

	def getRotate(self) :
		return self.__rotation
		
	def paint(self, painter, optionStyle, widget) :
		painter.setRenderHint(QPainter.Antialiasing)
		painter.setPen(self.lineStyle)
		painter.setBrush(self.background)
		if self.typeShape == 3 or self.typeShape == 4 or self.typeShape == 5 or self.typeShape== 6 :
			if self.typeShape == 3 :
				a = -60
			elif self.typeShape == 4 :
				a = -90
			elif self.typeShape == 6 :
				a = 90
			elif self.typeShape == 5 :
				a = 120
				
			path = QPainterPath()
			path.setFillRule(Qt.WindingFill)
			path.moveTo(self.point)
			path.arcTo(self.ellipse, a, 330)
			path.closeSubpath() 
			self.rect = path.controlPointRect()
			painter.drawPath(path)
			
		elif self.typeShape == 7 or self.typeShape == 8 or self.typeShape == 9 or self.typeShape== 10 :
			x = self.ellipse.x()
			y = self.ellipse.y()
			w = self.ellipse.width()
			h = self.ellipse.height()
			R = 0.1*w
			A = QPointF(x+0.9*w, y+h)
			B = QPointF(x+w, y+R)
			C = QPointF(x+R, y)
			D = QPointF(x, y+h-R)
			if self.typeShape == 7or self.typeShape == 8 :
				if self.typeShape == 7 :
					p1 = 0.8
					p2 = 0.6
				else :
					p1 = 0.4
					p2 = 0.2
				X1 = QPointF(x+p1*w, y+h)
				X2 = QPointF(x+p2*w, y+h)
				path = QPainterPath()
				path.setFillRule(Qt.WindingFill)
				path.moveTo(self.point)
				path.lineTo(X1)
				path.lineTo(A)
				path.arcTo(x+0.9*w, y+h-R, R, R, -90.0, 90.0)
				path.lineTo(B)
				path.arcTo(x+0.9*w, y, R, R, 0.0, 90.0)
				path.lineTo(C)
				path.arcTo(x, y, R, R, 90.0, 90.0)
				path.lineTo(D)
				path.arcTo(x, y+h-R, R, R, 180.0, 90.0)
				path.lineTo(X2)
				path.closeSubpath()
				self.rect = path.controlPointRect()
				painter.drawPath(path)
			elif self.typeShape == 9 or self.typeShape == 10 :
				if self.typeShape == 10 :
					p1 = 0.8
					p2 = 0.6
				else :
					p1 = 0.4
					p2 = 0.2
				X1 = QPointF(x+p2*w, y)
				X2 = QPointF(x+p1*w, y)
				path = QPainterPath()
				path.setFillRule(Qt.WindingFill)
				path.moveTo(self.point)
				path.lineTo(X1)
				path.lineTo(C)
				path.arcTo(x, y, R, R, 90.0, 90.0)
				path.lineTo(D)
				path.arcTo(x, y+h-R, R, R, 180.0, 90.0)
				path.lineTo(A)
				path.arcTo(x+0.9*w, y+h-R, R, R, -90.0, 90.0)
				path.lineTo(B)
				path.arcTo(x+0.9*w, y, R, R, 0.0, 90.0)
				path.lineTo(X2)
				path.closeSubpath()
				self.rect = path.controlPointRect()
				painter.drawPath(path)
				
		elif self.typeShape == 11 : 
			path = QPainterPath()
			path.addEllipse(self.ellipse)
			rect1 = QRectF(0.3*self.ellipse.x()+0.3*self.ellipse.width()/2.0+0.7*self.point.x()-self.ellipse.width()*0.3/2.0, \
					0.3*self.ellipse.y()+0.3*self.ellipse.height()/2.0+0.7*self.point.y()-self.ellipse.height()*0.3/2.0, \
					self.ellipse.width()*0.3, \
					self.ellipse.height()*0.3)
			rect2 = QRectF(self.point.x()-self.ellipse.width()*0.15/2.0, \
					self.point.y()-self.ellipse.height()*0.15/2.0, \
					self.ellipse.width()*0.15, \
					self.ellipse.height()*0.15)
			path.addEllipse(rect1)
			path.addEllipse(rect2)
			self.rect = path.controlPointRect()
			painter.drawPath(path)
		elif self.typeShape == 0 :
			self.rect = self.ellipse
			painter.drawRect(self.ellipse)
		elif self.typeShape == 1 :
			self.rect = self.ellipse
			painter.drawRoundedRect(self.ellipse, self.ellipse.width()*0.1, self.ellipse.height()*0.1)
		elif self.typeShape == 2 :
			self.rect = self.ellipse
			painter.drawEllipse(self.ellipse)
		# Ajout du texte dans la bulle principale.
		textRec = QRectF(self.ellipse.x()+0.1*self.ellipse.width(), self.ellipse.y()+0.1*self.ellipse.height(), self.ellipse.width()*0.8, self.ellipse.height()*0.8)
		painter.setFont(self.font)
		painter.setPen(QPen(self.colorFont))
		painter.drawText(textRec, (Qt.AlignVCenter | Qt.AlignCenter), self.text)
		
		if optionStyle.state & QStyle.State_Selected:
			Pen=QPen(QColor(220,220,220))
			Pen.setWidth(2)
			Pen.setJoinStyle(Qt.RoundJoin)
			Pen.setStyle(Qt.DashLine)
			painter.setPen(Pen)
			painter.setBrush(Qt.NoBrush)
			painter.drawRect(self.rect)


class TextItem(QGraphicsTextItem):
	"Item texte"
	def __init__(self, text, position, scene, font=QFont("Sans Serif", PointSize),
			color=QColor(0,0,0), rotation=0, z=1):
		QGraphicsTextItem.__init__(self, text)
		self.setFlags(QGraphicsItem.ItemIsSelectable|
				QGraphicsItem.ItemIsMovable)
		self.__rotation = 0
		self.setFont(font)
		self.setPos(position)
		self.setRotateR(rotation)
		self.setDefaultTextColor(color)
		scene.clearSelection()
		scene.addItem(self)
		self.setZValue(z)
		self.setSelected(True)
		#print "adresse classe", self
		EkdPrint(u"adresse classe %s" % self)

	def parentWidget(self):
		return self.scene().views()[0]
		
	def hexaColor(self):
		return self.defaultTextColor().toRgb().name()
	
	def mouseDoubleClickEvent(self, event):
		dialog = TextItemDlg(self, self.parentWidget())
		dialog.exec_()
	
	def setRotateR(self, rotation):
		self.__rotation += rotation
		#print self.__rotation
		EkdPrint(u"%s" % self.__rotation)
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(rotation)
	
	def setRotateL(self, rotation):
		self.__rotation -= rotation
		#print self.__rotation
		EkdPrint(u"%s" % self.__rotation)
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(-rotation)

	def getRotate(self):
		return self.__rotation


class BoxItem(QGraphicsItem):
	"Item boite rectangulaire"
	def __init__(self, position, scene, style=Qt.SolidLine, borderWidth=1, 
			boxColor = QColor('#000000'),
			rect=None, rotation=0, z=1) :
		QGraphicsItem.__init__(self)
		self.setFlags(QGraphicsItem.ItemIsSelectable|
				QGraphicsItem.ItemIsMovable|
				QGraphicsItem.ItemIsFocusable)
		if rect is None:
			rect = QRectF(0.0, 0.0, 20*PointSize, 10*PointSize)   #(-10 * PointSize, -PointSize,
					#20 * PointSize, 2 * PointSize)
		self.rect = rect
		self.style = style
		self.borderWidth = borderWidth
		self.boxColor = boxColor
		self.coin = carreRedim(self, scene,z+2,"Box",self)
		self.__rotation = 0
		self.setPos(position)
		self.setRotateR(rotation)
		scene.clearSelection()
		scene.addItem(self)
		self.setZValue(z)
		self.setSelected(True)
		self.setFocus()

	def parentWidget(self):
		return self.scene().views()[0]

	def boundingRect(self):
		return self.rect.adjusted(-2, -2, 2, 2)

	def paint(self, painter, option, widget):
		pen = QPen(self.style)
		pen.setColor(self.boxColor)
		pen.setWidth(self.borderWidth)
		if option.state & QStyle.State_Selected:
			pen.setColor(Qt.cyan)
		painter.setPen(pen)
		painter.drawRect(self.rect)

	def contextMenuEvent(self, event):
		wrapped = [] # indispensable mais je ne sais pas pourquoi
		#print "contextMenuEvent_contextMenuEvent_contextMenuEvent"
		EkdPrint(u"contextMenuEvent_contextMenuEvent_contextMenuEvent")
		menu = QMenu(self.parentWidget())
		for text, param in (
			(_(u"Contour &solide"), Qt.SolidLine),
			(_(u"Contour en &pointillets"), Qt.DashLine),
			(_(u"Contour en p&oints"), Qt.DotLine),
			(_(u"Contour en po&intillets et points"), Qt.DashDotLine),
			(_(u"Contour en pointillets et poin&ts (x2)"), Qt.DashDotDotLine),
			(_(u"Contour en noir"), QColor('#000000')),
			(_(u"Contour en rouge"), QColor('#FF0000')),
			(_(u"Contour en vert"), QColor('#00FF00')),
			(_(u"Contour en bleu"), QColor('#0000FF')),
			(_(u"Contour en jaune"), QColor('#FFFF00'))) :
			wrapper = partial(self.setStyle, param)
			wrapped.append(wrapper)
			menu.addAction(text, wrapper)
		menu.exec_(event.screenPos())

	def setStyle(self, style):
		if style in [Qt.SolidLine, Qt.DashLine, Qt.DotLine, Qt.DashDotLine, Qt.DashDotDotLine] :
			self.style = style
		else :
			self.boxColor = style
		self.update()

	def keyPressEvent(self, event):
		"""Redéfinition de la fonction appelée lors d'une sélection de touche clavier"""
		#QGraphicsItem.keyPressEvent(self, event)
		factor = PointSize / 4
		changed = False
		if event.modifiers() & Qt.ShiftModifier:
			if event.key() == Qt.Key_Left:
				self.rect.setRight(self.rect.right() - factor)
				changed = True
			elif event.key() == Qt.Key_Right:
				self.rect.setRight(self.rect.right() + factor)
				changed = True
			elif event.key() == Qt.Key_Up:
				self.rect.setBottom(self.rect.bottom() - factor)
				changed = True
			elif event.key() == Qt.Key_Down:
				self.rect.setBottom(self.rect.bottom() + factor)
				changed = True
		# Taille du trait
		if event.modifiers() & Qt.ControlModifier :
			if event.key() == Qt.Key_Up:
				self.borderWidth += 1
				changed = True
			if event.key() == Qt.Key_Down:
				self.borderWidth -= 1
				if self.borderWidth < 1 :
					self.borderWidth = 1
				changed = True
		if changed:
			self.update()
		else:
			QGraphicsItem.keyPressEvent(self, event)
	
	def setRotateR(self, rotation):
		self.__rotation += rotation
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(rotation)
	
	def setRotateL(self, rotation):
		self.__rotation -= rotation
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(-rotation)

	def getRotate(self):
		return self.__rotation

		
class GraphicsPixmapItem(QGraphicsPixmapItem):
	"Item image"
	def __init__(self, imageFile, pixmap, position, rotation=0, z=1):
		QGraphicsPixmapItem.__init__(self, pixmap)
		self.setFlags(QGraphicsItem.ItemIsSelectable|
				QGraphicsItem.ItemIsMovable|
				QGraphicsItem.ItemIsFocusable)
		self.__rotation = 0
		self.imageFile = imageFile
		self.setPos(position)
		self.setRotateR(rotation)
		self.setZValue(z)
		self.reduction = 1.0
		self.cropX = 0.0
		self.cropY = 0.0
		self.cropWidth = pixmap.width()
		self.cropHeight = pixmap.height()
		self.cropValueX = pixmap.width()/100.0
		self.cropValueY = pixmap.height()/100.0
		self.pixHeight = pixmap.height() # Hauteur de l'image initiale -> Ne doit jamais être modifié !
		self.pixWidth = pixmap.width() # Largeur de l'image initiale -> Ne doit jamais être modifié !
		self.selectUL = carreRedim(self,self.scene(),z,"Pix",self)
		self.setSelected(True)
		self.setFocus()

		
	def keyPressEvent(self, event):
		"""Redéfinition de la fonction appelée lors d'une sélection de touche clavier"""
		#QGraphicsItem.keyPressEvent(self, event)
		print "keyPressEvent on GraphicsPixmapItem"
		if event.modifiers() & Qt.ShiftModifier : # Réduction de l'image
			print "key event SHIFT"
			if event.key() == Qt.Key_Up :
				# crop de l'image par le bas
				self.cropHeight -= self.cropValueY
			if event.key() == Qt.Key_Down :
				# crop de l'image par le haut
				self.cropY += self.cropValueY
			if event.key() == Qt.Key_Right :
				# crop de l'image par la gauche
				self.cropX += self.cropValueX
			if event.key() == Qt.Key_Left :
				# crop de l'image par la droite
				self.cropWidth -= self.cropValueX

		elif event.modifiers() & Qt.AltModifier : # Agrandissement de l'image
			print "key event ALT"
			if event.key() == Qt.Key_Up :
				# décrop de l'image par le haut
				self.cropY -= self.cropValueY
				if self.cropY < 0.0 : self.cropY = 0.0
			if event.key() == Qt.Key_Down :
				# décrop de l'image par le bas
				self.cropHeight += self.cropValueY
			if event.key() == Qt.Key_Right :
				# décrop de l'image par la droite
				self.cropWidth += self.cropValueX
			if event.key() == Qt.Key_Left :
				# crop de l'image par la droite
				self.cropX -= self.cropValueX
				if self.cropX < 0.0 : self.cropX = 0.0

		pix = QPixmap(self.imageFile).copy(self.cropX, self.cropY, self.cropWidth,\
					self.cropHeight).scaled(self.pixWidth*self.reduction, self.pixHeight*self.reduction, \
					Qt.KeepAspectRatio, Qt.SmoothTransformation)
		self.setPixmap(pix)
		
	def mouseMoveEvent(self, event) :
		"""Redéfinition de la fonction appelée lors de évenements de la souris sur la poignée"""
		QGraphicsItem.mouseMoveEvent(self, event)
		if self.scene().grilleMagnAct() :
			P = event.scenePos()
			x = xi=P.x() 
			n=0
			deltax =self.scene().width()/self.scene().getColumn()
			while n*deltax < xi :
				x = n*deltax
				n += 1
		
			y = yi = P.y()
			n=0 
			deltay = self.scene().height()/self.scene().getRow()
			while n*deltay < yi :
				y = n*deltay
				n += 1
			self.setPos(x, y)
		
	def setRotateR(self, rotation):
		self.__rotation += rotation
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(rotation)

	def setRotateL(self, rotation):
		self.__rotation -= rotation
		while self.__rotation >= 360:
			self.__rotation -= 360
		self.rotate(-rotation)
	
	def getRotate(self):
		return self.__rotation

class GraphicsScene(QGraphicsScene) :
	def __init__(self, imageFile=None, parent=None):
		QGraphicsScene.__init__(self, parent)
		self.imageFile = imageFile
		self.background = None
		self.grilleMagnetique = False # Activation ou désactivation de la grille magnétique pour le positionnement des images
		self.grille = None
		self.row = 20
		self.column = 20

	def setGrilleMagnetique(self, status = True) :
		self.grilleMagnetique = status

	def grilleMagnAct(self) :
		return self.grilleMagnetique

	def setRow(self, row) :
		self.row = row

	def getRow(self) :
		return self.row

	def setColumn(self, column) :
		self.column = column
		
	def getColumn(self) :
		return self.column

class GraphicsView(QGraphicsView):

	def __init__(self, parent=None):
		QGraphicsView.__init__(self, parent)
		self.setDragMode(QGraphicsView.RubberBandDrag)
		self.setRenderHint(QPainter.Antialiasing)
		self.setRenderHint(QPainter.TextAntialiasing)
		self.setBackgroundBrush(QBrush(QColor(50,50,50), Qt.Dense7Pattern))
	
	def wheelEvent(self, event):
		factor = 1.41 ** (-event.delta() / 240.0)
		self.scale(factor, factor)


class Image_Divers_TxtSurImg(QWidget):
	# -----------------------------------
	# Cadre accueillant les widgets de :
	# Image >> Divers >> Texte sur images
	# -----------------------------------
	
	ZOOM_MOINS,ZOOM_PLUS,ZOOM_REEL,ZOOM_FIT = range(4)

	def __init__(self, statusBar, geometry):
		QWidget.__init__(self)
		
		# Fonctions communes à plusieurs cadres du module Image
		self.base = Base()

		# Gestion de la configuration via EkdConfig
		# Paramètres de configuration
		self.config = EkdConfig
		self.nProc = 0

		vbox = QVBoxLayout() # Layout principal
		# Modification de structure pour mettre ce module conforme au nouveau design.
		# 1.Ajout du tab principal
		self.tabwidget=QTabWidget()

		# 2. Création du tab de sélection de fichier source - 
		# basé sur le widget de sélection standard
		self.afficheurImgSource=SelectWidget(geometrie = geometry, noImage = True)
		## ---------------------------------------------------------------------
		# Variables pour la fonction tampon
		## ---------------------------------------------------------------------
		self.typeEntree = "image" # Défini le type de fichier source.
		self.typeSortie = "image" # Défini le type de fichier de sortie.
		self.sourceEntrees = self.afficheurImgSource # Fait le lien avec le sélecteur de fichier source.
		
		self.connect(self.afficheurImgSource, SIGNAL("pictureChanged(int)"), self.modifImgSource)
		self.connect(self.afficheurImgSource, SIGNAL("pictureSelected()"), self.modifImgSource)
		self.tabwidget.addTab(self.afficheurImgSource, _(u'Image(s) source'))

		# 3. Création du tab réglages
		# Grille magnétique
		vlay = QVBoxLayout()
		hlay = QHBoxLayout()
		self.grille = None
		self.grilleCheck = QCheckBox(QString(_(u"Grille magnétique ?")))
		self.grilleCheck.setChecked(False)
		self.grilleCheck.setEnabled(False)
		hlay.addWidget(self.grilleCheck)
		grilleRow = QLabel(QString(_(u"Nbr de ligne : ")))
		self.grilleRow = QSpinBox()
		self.grilleRow.setRange(1, 100)
		self.grilleRow.setValue(20)
		self.grilleRow.setEnabled(False)
		grilleColumn = QLabel(QString(_(u"Nbr de colonne : ")))
		self.grilleColumn = QSpinBox()
		self.grilleColumn.setRange(1, 100)
		self.grilleColumn.setValue(20)
		self.grilleColumn.setEnabled(False)
		############### combobox de navigation des pages ##################
		self.listePage = QComboBox()
		hlay.addWidget(grilleRow)
		hlay.addWidget(self.grilleRow)
		hlay.addWidget(grilleColumn)
		hlay.addWidget(self.grilleColumn)
		hlay.addWidget(self.listePage)
		vlay.addLayout(hlay)

		self.connect(self.grilleCheck, SIGNAL("stateChanged(int)"), self.actionGrille)
		self.connect(self.grilleRow, SIGNAL("valueChanged(int)"), self.updateGrille)
		self.connect(self.grilleColumn, SIGNAL("valueChanged(int)"), self.updateGrille)
		self.connect(self.listePage, SIGNAL("currentIndexChanged(int)"), self.changePage)

		self.listFileNames = []
		self.z = 1 # "Hauteur" initiale des graphicsItems ajoutés
		self.baseImage = None
		self.copiedItem = QByteArray()
		self.pasteOffset = 5
		self.prevPoint = QPoint()
		self.addOffset = 5
		self.borders = []

		self.widReglage = QWidget()

		self.view = GraphicsView()
		self.scenes = []
		#self.view.setScene(self.scene)
		
		# Image de fond
		#self.background = QGraphicsPixmapItem()
		
		buttonLayout = QVBoxLayout()
		# Liste qui servira à activer/désactiver les boutons
		self.buttonsList = []
		# Liste des boutons à éviter sous PyQt4.1.0 (ex.ubuntu feisty) à cause d'un bogue
		# sur les fonctions associées
		self.buttonListeNoireFeisty = []
		self.zoomPlus = partial(self.zoom, Image_Divers_TxtSurImg.ZOOM_PLUS)
		self.zoomMoins = partial(self.zoom, Image_Divers_TxtSurImg.ZOOM_MOINS)
		self.zoomReel = partial(self.zoom, Image_Divers_TxtSurImg.ZOOM_REEL)
		self.zoomFit = partial(self.zoom, Image_Divers_TxtSurImg.ZOOM_FIT)
		layoutEdition = QHBoxLayout()
		for text, slot, icon in (
			(_(u"Ajouter &Texte"), self.addText, "Icones/text_add.png"),
			(_(u"Ajouter &Boite"), self.addBox, "Icones/ajouter_shape.png"),
			(_(u"Ajouter Ima&ge"), self.addPixmap, "Icones/image.png"),
			(_(u"Ajouter bulle BD"), self.addStrip, "Icones/textStrip.png"),
			(_(u"C&opier"), self.copy, "Icones/copy.png"),
			(_(u"Cou&per"), self.cut, "Icones/cut.png"),
			(_(u"Co&ller"), self.paste, "Icones/paste.png"),
			(_(u"&Effacer..."), self.delete, "Icones/bin.png"),
			(_(u"&Monter"), self.upItem, "Icones/up.png"),
			(_(u"Descen&dre"), self.downItem, "Icones/down.png"),
			(_(u"Pivoter &Droite"), self.rotateR, "Icones/rotationd.png"),
			(_(u"Pivoter &Gauche"), self.rotateL, "Icones/rotationg.png"),
			(_(u"Zoom &fit"), self.zoomFit, "Icones/fenetre.png"),
			(_(u"Zoom &avant"), self.zoomPlus, "Icones/zoomplus.png"),
			(_(u"Zoom a&rrière"), self.zoomMoins, "Icones/zoommoins.png"),
			(_(u"Zoom &100%"), self.zoomReel, "Icones/taillereelle.png"),
			):
			if text in [_(u"C&opier"),_(u"Cou&per"),_(u"Co&ller"),_(u"&Effacer...")]:
				button = QToolButton()
				button.setIcon(QIcon(icon))
				button.setIconSize(QSize(16, 16))
				button.setToolTip(text)
				layoutEdition.addWidget(button)
				self.buttonListeNoireFeisty.append(button)
			else :
				if icon != None :
					button = QPushButton(QIcon(icon), text)
				else :
					button = QPushButton(text)
				buttonLayout.addWidget(button)

			button.setEnabled(False)
			self.buttonsList.append(button)
			self.connect(button, SIGNAL("clicked()"), slot)

			if text == _(u"&Effacer...") : # provisoire...
				buttonLayout.addLayout(layoutEdition)
				buttonLayout.addStretch(0)
			if text == _(u"Pivoter &Gauche"): # prochainement...
				buttonLayout.addStretch(0)
		buttonLayout.addStretch()

		# ComboBox de choix du format de sortie
		self.choixSortie = QComboBox()
		self.listFormatSortie = []
		self.indexFormatSortie = 0
		for text, format, extension, compression in (
				(_(u"PNG"),"PNG",u".png", 1),
				(_(u"JPEG"),"JPEG",u".jpg", 2),
				(_(u"BMP"),"BMP",u".bmp", 0),
				(_(u"TIFF"),"TIFF",u".tiff", 0),
				(_(u"PPM"),"PPM",u".ppm", 0)) :
			self.choixSortie.addItem(text)
			self.listFormatSortie.append([format,extension,compression])
		self.connect(self.choixSortie, SIGNAL("currentIndexChanged(int)"), self.setFormatSortie)
		buttonLayout.addWidget(self.choixSortie)
		
		self.labelQualite = QLabel(_(u"Qualité de l'image"))
		self.cbQualite = QComboBox()
		self.cbQualite.addItems(["0","10","20","30","40","50","60","70","80","85","90","95","100"])
		self.cbQualite.setCurrentIndex(8)
		hboxQ = QHBoxLayout()
		hboxQ.addWidget(self.labelQualite)
		hboxQ.addWidget(self.cbQualite)
		buttonLayout.addLayout(hboxQ)
		self.labelQualite.hide()
		self.cbQualite.hide()

		hbox = QHBoxLayout()
		hbox.addWidget(self.view, 1)
		hbox.addLayout(buttonLayout)
		vlay.addLayout(hbox)
		self.widReglage.setLayout(vlay)
		self.tabwidget.addTab(self.widReglage, _(u"Réglage"))
		
		# 4. Création du tab de visualisation du résultat
		self.afficheurImgDestination=Lecture_VisionImage(statusBar)
		self.tabwidget.addTab(self.afficheurImgDestination, _(u'Visualisation des images créées'))

		# 5. Création du tab Info
		self.Logs = QTextEdit() # Zone d'affichage des infos (Zone 
		# acceptant le formatage HTML et avec assenceur automatique si nécessaire)
		self.tabwidget.addTab(self.Logs, _(u'Infos'))
		
		#-----------------
		# widgets du bas
		#-----------------
		
		# Boutons
		boutAide=QPushButton(_(u" Aide"))
		boutAide.setIcon(QIcon("Icones/icone_aide_128.png"))
		self.connect(boutAide, SIGNAL("clicked()"), self.afficherAide)
		
		self.boutAppliquer=QPushButton(_(u"Appliquer"))
		self.boutAppliquer.setIcon(QIcon("Icones/icone_appliquer_128.png"))
		
		# Bouton inactif au départ
		self.boutAppliquer.setEnabled(False)
		
		self.connect(self.boutAppliquer, SIGNAL("clicked()"), self.appliquer)
		
		# Ligne de séparation juste au dessus des boutons
		ligne = QFrame()
		ligne.setFrameShape(QFrame.HLine)
		ligne.setFrameShadow(QFrame.Sunken)
		
		hbox=QHBoxLayout()
		hbox.addWidget(boutAide)
		hbox.addStretch()
		hbox.addWidget(self.boutAppliquer)

		vbox.addWidget(self.tabwidget)
		vbox.addWidget(ligne)
		vbox.addLayout(hbox)
		self.setLayout(vbox)
		
	def changePage(self, index) :
		"""Action lors du changement de page"""
		self.view.setScene(self.scenes[index])
		self.grilleCheck.setChecked(self.scenes[index].grilleMagnetique)
		
	def	 actionGrille(self, state) :
		self.view.scene().setGrilleMagnetique(state)
		self.view.scene().setRow(self.grilleRow.value())
		self.view.scene().setColumn(self.grilleColumn.value())
		if state :
			self.grilleRow.setEnabled(True)
			self.grilleColumn.setEnabled(True)
			self.view.scene().grille = grilleMagnetique(width=self.view.scene().background.pixmap().width(), height=self.view.scene().background.pixmap().height(), row=self.grilleRow.value(), column=self.grilleColumn.value())
			self.view.scene().addItem(self.view.scene().grille)
			self.view.scene().grille.setPos(0.0, 0.0)
		else :
			self.grilleRow.setEnabled(False)
			self.grilleColumn.setEnabled(False)
			if self.view.scene().grille != None :
				self.view.scene().removeItem(self.view.scene().grille)
			self.view.scene().grille = None

	def updateGrille(self) :
		self.actionGrille(False)
		self.actionGrille(True)

	def setFormatSortie(self, index) :
		self.indexFormatSortie = index
		if self.listFormatSortie[index][2] == 2 :
			self.labelQualite.show()
			self.cbQualite.show()
		else :
			self.labelQualite.hide()
			self.cbQualite.hide()


	def modifImgSource(self, i=True):
		"""On active ou désactive les boutons d'action et on recharge le pseudo-aperçu de planche-
		contact en fonction du nombre d'images présentes dans le widget de sélection"""
		self.boutAppliquer.setEnabled(i)
			
		selectedImg = self.afficheurImgSource.getFile()
		self.updatePageList()
		if self.setBackgroundImg(selectedImg) :
			self.grilleCheck.setEnabled(True)
			if PYQT_VERSION_STR != "4.1.0":
				for button in self.buttonsList:
					button.setEnabled(True)
			else:
				# Pour empêcher le bogue de PyQt4.1.0 Feisty
				for button in self.buttonsList:
					if button not in self.buttonListeNoireFeisty:
						button.setEnabled(True)
			self.zoom(Image_Divers_TxtSurImg.ZOOM_FIT)

	def updatePageList(self) :
		back = self.afficheurImgSource.getFiles()
		# Vérification des images existantes et ajout des fonds manquants
		for img in back :
			present = 0
			for scene in self.scenes :
				if scene.imageFile == img :
					present = 1
					break
			if not present :
				# Création de l'objet QPixmap de l'image de base
				pixmap = QPixmap(img)
				bkgScene = GraphicsScene(img, self)
				# Ajout de la nouvelle image
				bkgScene.setSceneRect(0, 0, pixmap.width(), pixmap.height())
				bkgScene.background = bkgScene.addPixmap(pixmap)
				bkgScene.background.setZValue(0)
				self.scenes.append(bkgScene)

		pageList = QStringList()
		i = 1
		baseIndex = 0
		for scene in self.scenes :
			present = 0
			for img in back :
				if scene.imageFile == img :
					present = 1
					pageList.append(QString(_(u"Page %i" % i)))
					if img == self.baseImage :
						baseIndex = i
					i += 1
					break
			if not present :
				# suppression de la liste des fonds
				self.scenes.remove(scene)
		
		self.listePage.clear()
		self.listePage.addItems(pageList)
		if pageList.count() > 0 :
			self.listePage.setCurrentIndex(baseIndex)
			self.changePage(baseIndex)

	def setBackgroundImg (self, selectedImg) :
		if selectedImg and selectedImg != self.baseImage :
			for image in self.scenes :
				if selectedImg == image.imageFile :
					self.view.setScene(image)
					return True
		else :
			self.grilleCheck.setEnabled(False)
			return False


	def position(self, pixmap=None):
		#print "QCursor.pos()", QCursor.pos().x(), QCursor.pos().y()
		EkdPrint(u"QCursor.pos() %s %s" % (QCursor.pos().x(), QCursor.pos().y()))
		point = self.mapFromGlobal(QCursor.pos())
		#print "self.mapFromGlobal(QCursor.pos()", point.x(), point.y()
		EkdPrint(u"self.mapFromGlobal(QCursor.pos() %s %s" % (point.x(), point.y()))
		if not self.view.geometry().contains(point) or pixmap:
			#print "if not self.view.geometry().contains(point) or pixmap"
			EkdPrint(u"if not self.view.geometry().contains(point) or pixmap")
			coord = random.randint(36, 144)
			point = QPoint(coord, coord)
		else:
			#print "else de if not self.view..."
			EkdPrint(u"else de if not self.view...")
			if point == self.prevPoint:
				#print "if point == self.prevPoint"
				EkdPrint(u"if point == self.prevPoint")
				point += QPoint(self.addOffset, self.addOffset)
				self.addOffset += 5
			else:
				#print "else de if point..."
				EkdPrint(u"else de if point...")
				self.addOffset = 5
				self.prevPoint = point
		#print "point", point.x(), point.y(), '\n'
		EkdPrint(u"upoint %s %s\n" % (point.x(), point.y()))
		# La position du point haut-gauche du rectangle encadrant le texte
		EkdPrint(u"self.view.mapToScene(point) %s %s" % (self.view.mapToScene(point).x(), 
			self.view.mapToScene(point).y()))
		return self.view.mapToScene(point)


	def addText(self):
		self.z += 1
		dialog = TextItemDlg(position=self.position(), scene=self.view.scene(), parent=self, z=self.z)
		dialog.exec_()
	

	def addBox(self):
		self.z += 1
		BoxItem(self.position(), self.view.scene(), z=self.z)

	def addStrip(self) :
		self.z += 1
		dialog = TextItemDlg2(position=self.position(), scene=self.view.scene(), z=self.z)
		dialog.exec_()

	def addPixmap(self):
		formats = ["*.%s" % unicode(format).lower() \
			for format in QImageReader.supportedImageFormats()]
		path = self.base.getRepSource(self.config)
		txt = _(u"Fichiers Image")
		fname = unicode(QFileDialog.getOpenFileName(self, "Ouvrir des images",
			path, "%s (%s);;%s" %(txt, " ".join(formats), FORMAT)))
		if not fname: return
		self.base.setRepSource(self.config, fname)
		self.createPixmapItem(fname, QPixmap(fname), self.position(pixmap=True))
	

	def createPixmapItem(self, imageFile, pixmap, position, rotation=0):
		self.z += 1
		item = GraphicsPixmapItem(imageFile, pixmap, position, rotation, z=self.z)
		item.setFlags(QGraphicsItem.ItemIsSelectable|
			QGraphicsItem.ItemIsMovable)
		self.view.scene().clearSelection()
		self.view.scene().addItem(item)
		item.setZValue(self.z+1)
		self.z += 1
		item.setSelected(True)
	

	def selectedItem(self):
		items = self.view.scene().selectedItems()
		if len(items) == 1:
			return items[0]
		print "DEBUG : More than one item selected"
		return None
	

	def copy(self):
		item = self.selectedItem()
		if item is None:
			print "DEBUG : More than one item selected"
			return
		self.copiedItem.clear()
		self.pasteOffset = 5
		stream = QDataStream(self.copiedItem, QIODevice.WriteOnly)
		self.writeItemToStream(stream, item)
	

	def cut(self):
		item = self.selectedItem()
		if item is None:
			print "DEBUG : More than one item selected"
			return
		self.copy()
		self.view.scene().removeItem(item)
		del item
	

	def paste(self):
		if self.copiedItem.isEmpty():
			return
		stream = QDataStream(self.copiedItem, QIODevice.ReadOnly)
		self.readItemFromStream(stream, self.pasteOffset)
		self.pasteOffset += 5


	def upItem(self) :
		'''Fonction pour relever le/les item(s) sélectionné(s))'''
		for item in self.view.scene().selectedItems():
			z = item.zValue()
			item.setZValue(z+1)


	def downItem(self) :
		'''Fonction pour descendre le/les item(s) sélectionné(s))'''
		for item in self.view.scene().selectedItems():
			z = item.zValue()
			if z>1 : # Pour éviter de placer un élément en dessous de l'image source qui est 
				 # au niveau 0.
				item.setZValue(z-1)
	

	def rotateR(self):
		for item in self.view.scene().selectedItems():
			item.setRotateR(11.25)
	

	def rotateL(self):
		for item in self.view.scene().selectedItems():
			item.setRotateL(11.25)
	

	def delete(self):
		items = self.view.scene().selectedItems()
		#print "items sélectionnés", items ###
		EkdPrint(u"items sélectionnés %s" % items)
		txt1,txt2=_(u"Effacer"),_(u"élément")
		if len(items) != 1: s = "s"
		else: s = ""
		if len(items) and QMessageBox.question(self,
			_(u"Texte sur images - Effacer"),
			"%s %d %s%s?" % (txt1,len(items),txt2,s),
			QMessageBox.Yes|QMessageBox.No) == QMessageBox.Yes:
			while items:
				item = items.pop()
				if item.data(0).toString() == QString("control") or item.data(0).toString() == QString("grille") :
					return
				#print "item?", item
				EkdPrint(u"item? %s" % item)
				self.view.scene().removeItem(item)
				del item
	
	
	def readItemFromStream(self, stream, offset=0):
		type_ = QString()
		position = QPointF()
		stream >> type_ >> position
		rotation = stream.readInt16()
		if offset:
			position += QPointF(offset, offset)
		if type_ == "Text":
			text = QString()
			font = QFont()
			color = QColor()
			stream >> text >> font >> color
			self.z += 1
			TextItem(text, position, self.view.scene(), font, color, rotation, self.z)
		elif type_ == "Pixmap":
			pixmap = QPixmap()
			stream >> pixmap
			self.createPixmapItem(pixmap, position, rotation)
		elif type_ == "Box":
			rect = QRectF()
			stream >> rect
			style = Qt.PenStyle(stream.readInt16())
			borderWidth = stream.readInt16()
			boxColor = QColor()
			stream >> boxColor 
			self.z += 1
			BoxItem(position, self.view.scene(), style, borderWidth, boxColor, rect, rotation, self.z)
		elif type_ == "Strip":
			text = QString()
			font = QFont()
			colorFont = QColor()
			stream >> text >> font >> colorFont
			background = QBrush()
			stream >> background
			lineStyle = QPen()
			ellipse = QRectF()
			point = QPointF()
			typeShape = QPen()
			stream >> lineStyle >> ellipse >> point
			typeShape = stream.readInt16()
			self.z += 1
			BDStripItem(text, position, self.view.scene(), font, colorFont, background, lineStyle, rotation = rotation, z = self.z, ellipse = ellipse, point = point, typeShape = typeShape)

	def writeItemToStream(self, stream, item):
		if isinstance(item, QGraphicsTextItem):
			stream << QString("Text") << item.pos()
			stream.writeInt16(item.getRotate())
			stream << item.toPlainText() << item.font() << item.defaultTextColor()
		elif isinstance(item, QGraphicsPixmapItem):
			stream << QString("Pixmap") << item.pos()
			stream.writeInt16(item.getRotate())
			stream << item.pixmap()
		elif isinstance(item, BoxItem):
			stream << QString("Box") << item.pos()
			stream.writeInt16(item.getRotate())
			stream << item.rect
			stream.writeInt16(item.style)
			stream.writeInt16(item.borderWidth)
			stream << item.boxColor
		elif isinstance(item, BDStripItem):
			stream << QString("Strip") << item.pos()
			stream.writeInt16(item.getRotate())
			stream << QString(item.text) << QFont(item.font) << QColor(item.colorFont)
			stream << QBrush(item.background) << QPen(item.lineStyle)
			stream << QRectF(item.ellipse) << QPointF(item.point)
			stream.writeInt16(item.typeShape)
	

	def appliquer(self):
		"Conversion des images: ajout de textes, images et boites"
		
		# Utilisation de la nouvelle boîte de dialogue de sauvegarde
		suffix=""
		fname = EkdSaveDialog(self, mode="image", suffix=suffix, title=_(u"Sauver"), multiple=True)
		fname = fname.getFile()

		if not fname: return

		# Gestion de l'extension
		if fname.endswith(self.listFormatSortie[self.indexFormatSortie][1]) :
			fname = fname[:-len(self.listFormatSortie[self.indexFormatSortie][1])]

		# Progression
		progress=QProgressDialog(_(u"Conversion en cours..."), _(u"Arrêter"), 0, 100)
		progress.setWindowTitle(_(u'EnKoDeur-Mixeur. Fenêtre de progression'))
		progress.show()
		progress.setValue(0)

		# Module traitement par lot
		lstImg = self.afficheurImgSource.getFiles()
		nbrImg = len(lstImg)
		lstFname = []
		k = 1
		for bimg in lstImg :
			self.setBackgroundImg(bimg)
			# Enregistrement de l'image composée
			imgDim = self.view.scene().sceneRect()
			imgFinal = QImage(imgDim.width(), imgDim.height(), QImage.Format_ARGB32)
			self.view.scene().clearSelection()
			for item in self.view.scene().items() :
				if item.data(0).toString() == QString("control") or item.data(0).toString() == QString("grille") :
					item.hide()
			self.view.scene().render(QPainter(imgFinal))
			if self.listFormatSortie[self.indexFormatSortie][2] == 2 : 
			# Qualité = valeur de la combobox
				qu = int(self.cbQualite.currentText())
			elif self.listFormatSortie[self.indexFormatSortie][2] == 0 : 
			# Qualité 100 pour les images sans compression
				qu = 100
			else : # Compression maximale pour les images PNG car format non destructif.
				qu = 0

			if imgFinal.save(fname+string.zfill(str(k), 5)+\
				self.listFormatSortie[self.indexFormatSortie][1],\
				self.listFormatSortie[self.indexFormatSortie][0], qu) :
				lstFname.append(fname+string.zfill(str(k), 5)+\
					self.listFormatSortie[self.indexFormatSortie][1])
			else :
				#print "Erreur lors de la sauvegarde de l'image"
				EkdPrint(u"Erreur lors de la sauvegarde de l'image")
			progress.setValue(int(100*k/nbrImg))
			k += 1
			for item in self.view.scene().items() :
				if item.data(0).toString() == QString("control") or item.data(0).toString() == QString("grille") :
					item.show()
			
		# Affichage du résultat
		self.afficheurImgDestination.cheminImage = u""
		self.afficheurImgDestination.updateImages(lstFname, cheminImage=u"")
		# Mise à jour du log
		self.updateLog(lstImg, lstFname)


	def updateLog(self, images, sorties) :
		"""Fonction pour la mise à jour des informations de log données à l'utilisateur en fin de 
		process sur les données entrées, et le résultat du process"""
		msgIm = _(u"<p>####################################<br># Images \
			chargées<br>####################################</p>")
		for i in images :
			msgIm += unicode(i)+u"<br>"

		msgOut = _(u"<br><p>####################################<br># Fichiers de \
			sortie<br>####################################</p>")
		for s in sorties :
			msgOut += unicode(s)+u"<br>"

		self.Logs.setHtml(QString(msgIm+msgOut))


	def zoom(self, val):
		if val==Image_Divers_TxtSurImg.ZOOM_PLUS:
			self.view.scale(1.2, 1.2)
		elif val==Image_Divers_TxtSurImg.ZOOM_MOINS:
			self.view.scale(0.8, 0.8)
		elif val==Image_Divers_TxtSurImg.ZOOM_REEL:
			self.view.resetTransform()
		elif val==Image_Divers_TxtSurImg.ZOOM_FIT :
			self.view.fitInView(self.view.scene().background, Qt.KeepAspectRatio)
	

	def afficherAide(self):
		"Boîte de dialogue de l'aide"

		messageAide = EkdAide(parent=self)
		messageAide.setText(_(u"<p><b>Ici vous pouvez ajouter du texte, des cadres ou des petites \
		images comme des logos sur des images. Cela peut être utile pour <i>signer</i> ou indiquer\
		la provenance d'un lot d'images (avant par exemple de les diffuser sur internet).</b></\
		p><p><b>De nombreux réglages vous sont proposés (dans l'onglet 'Réglage') afin d'inscrire\
		et disposer comme bon vous semble du texte sur un lot d'images.</b></p>\
		<p>Dans l'onglet <b>Image(s) source</b> cliquez sur le bouton <b>Ajouter</b>, une boîte \
		de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez \
		les sous-répertoires), allez chercher vos image(s). Si vous voulez sélectionner plusieurs \
		images d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée \
		(tout en sélectionnant vos images), cliquez sur <b>Ajouter</b>. Toujours dans l'onglet \
		<b>Image(s) source</b> sélectionnez une des miniatures.</p><p>Allez maintenant dans \
		l'onglet <b>Réglages</b>, l'image de la miniature que vous venez de sélectionner est \
		affichée. Vous pouvez zoomer ou dézoomer l'image avec le bouton du milieu de la souris. \
		Dans cet onglet <b>Réglages</b> (et sur la droite), vous voyez toute une série de boutons \
		(qui correspondent aux différentes actions que vous pouvez effectuer sur l'image ou sur \
		le texte que vous allez écrire sur cette image). Nous allons maintenant, simplement \
		ajouter un texte, pour ce faire cliquez sur le bouton <b>Ajouter texte</b>, la boîte de \
		dialogue <b>Texte sur images - Ajouter texte</b> apparaît, avant d'écrire quoi que ce \
		soit (dans le champ réservé à cet effet), faites le choix de la <b>Police</b>, de la \
		<b>Taille</b> et de la <b>Couleur</b>, écrivez maintenant votre texte, une fois fait, \
		cliquez sur le bouton <b>OK</b>. Vérifiez que votre texte ne dépasse pas de l'image (si \
		cela est la cas, double-cliquez sur le texte en question, la boîte de dialogue de saisie \
		va réapparaître) et faites ce qu'il faut ... . Vous pouvez positionner le texte sur \
		l'image en bougeant le cadre où se trouve le texte avec la souris. Vous pouvez si vous le \
		désirez ajouter une boîte (par le bouton <b>Ajouter Boîte</b>). Pour choisir le contour \
		de la boîte, faites un clic droit dessus, un menu vous permettra de choisir le contour \
		que vous désirez. En ce qui concerne la taille de la boîte, il est possible de régler la \
		taille de celle-ci en pressant simultanément les touches <b>Shift</b> et <b>Flèche droite \
		(ou gauche)</b> pour changer la taille en largeur, <b>Shift</b> et <b>Flèche haut (ou \
		bas)</b> pour changer la taille en hauteur (pas besoin d'utiliser la souris pour changer \
		la taille). Vous pouvez ajouter une image (par le bouton <b>Ajouter Image</b>), \
		sélectionnez le chemin de votre image (puis l'image elle-même) dans la boîte de dialogue \
		<b>Ouvrir des images</b>, cliquez sur le bouton <b>Ouvrir</b>. Certaines actions peuvent \
		être effectuées (comme Copier, Couper, Coller, Effacer) par les boutons juste en dessous \
		de <b>Ajouter Image</b> (positionnez votre souris sur ces boutons et il vous sera indiqué \
		à quoi ils correspondent). Vous pouvez déplacer les éléments un à un dans la scène en \
		cliquant dessus et en déplaçant la souris sans relacher le clic gauche (vu précédemment). \
		Vous pouvez aussi déplacer plusieurs éléments en même temps comme expliqué précédemment \
		mais en 'dessinant' au préalable un rectangle qui les englobera (bouton gauche de la \
		souris maintenu en la déplaçant). L'ordre d'affichage des éléments peut-être modifié au \
		moyen des boutons <b>Monter</b> et <b>Descendre</b>.</p><p>Sélectionnez votre format \
		d'image (PNG, JPEG, BMP, TIFF ou PPM), c'est à dire votre extension d'image, dans la \
		liste déroulante (tout en bas) prévue à cet effet. Dans le cas d'une sélection JPEG, \
		n'oubliez pas de régler la <b>Qualité de l'image</b>.</p><p>Une fois tout ceci fait, \
		cliquez sur le bouton <b>Appliquer</b>, sélectionnez le répertoire de sauvegarde, \
		indiquez votre <b>Nom de fichier</b>, cliquez sur le bouton <b>Enregistrer</b>.</p><p>Si \
		vous faites un clic droit de la souris (sur l'image) dans l'onglet <b>Visualisation des \
		images créées</b>, vous accédez à des paramètres vous permettant différents affichages de \
		la dite image. De même dans cet onglet vous pouvez lancer la visualisation des images par \
		le bouton <b>Lancer le diaporama</b> (le bouton violet avec une flèche blanche vers la \
		droite).</p><p>L'onglet <b>Infos</b> vous permet de voir le filtre utilisé, les image(s) \
		chargée(s) et les image(s) convertie(s).</p>"))
		messageAide.show()


	def save(self) :
		self.afficheurImgSource.saveFileLocation(self.idSection)


	def load(self) :
		self.afficheurImgSource.loadFileLocation(self.idSection)
